/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pa165.mockitodemo.test;

import java.util.List;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;

/**
 *
 * @author tomp
 */
public class ArgumentMatchingTest {
    
    private List<String> mockedList;
    
    public ArgumentMatchingTest() {
    }
    
    @Before
    public void setUp() {
         //mock creation
        mockedList = mock(List.class);
        
        // stubbing its behavior
        // if any valid (int) arg is passed, return "some int" 
        when(mockedList.get(anyInt())).thenReturn("some int");
    }
    
    @Test
    public void mockitoArgumentMatching() {

        //using mock object
        mockedList.add("one");
        
        // now we get the added "one" or something else?
        assertEquals("some int", mockedList.get(0));
        
        // yeaah, we got "some int" as the 0 matched "anyInt()"
    }
}