/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pa165.mockitodemo.test;

import java.util.List;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import org.mockito.ArgumentMatcher;
import static org.mockito.Mockito.*;

/**
 *
 * @author tomp
 */
public class CustomArgumentMatchingTest {

    private List mockedList;

    public CustomArgumentMatchingTest() {
    }

    @Before
    public void setUp() {
        //mock creation
        mockedList = mock(List.class);

        // custom argument matching
        // if some valid arg is passed, return true 
        // the validator is completely custom
        when(mockedList.contains(argThat(isValid())))
                .thenReturn(true);
    }

    private ArgumentMatcher isValid() {
        return new ArgumentMatcher() {
            @Override
            public boolean matches(Object argument) {
                return "one".equals(argument) || "two".equals(argument);
            }
        };
    }

    @Test
    public void mockitoCustomArgumentMatching() {

        // does the list contain "one" or "two"?
        assertTrue(mockedList.contains("one"));
        assertTrue(mockedList.contains("two"));
        // but not three
        assertFalse(mockedList.contains("three"));
    }
}