/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pa165.mockitodemo.test;

import java.util.List;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;

/**
 *
 * @author tomp
 */
public class StubbingTest {
    
    private List<String> mockedList;
    
    public StubbingTest() {
    }
    
    @Before
    public void setUp() {
         //mock creation
        mockedList = mock(List.class);
        
        // stubbing its behavior
        when(mockedList.get(0)).thenReturn("one");
        when(mockedList.get(1)).thenReturn("two");
    }
    
    @Test
    public void mockitoStubbing() {

        //using mock object
        mockedList.add("one");
        
        // now we get the added String "one" and "two"
        assertEquals("one", mockedList.get(0));
        assertEquals("two", mockedList.get(1));
        
        mockedList.clear();

        // interestingly, we still get the added String "one", but why not?!
        assertEquals("one", mockedList.get(0));
    }
}